package extThopt;

import javax.swing.*;
import java.awt.*;
import java.util.*; 
import java.io.*;

public class MapImage extends JFrame
//implements FilenameFilter
{
    protected static java.util.ResourceBundle resIntTh_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    ImageIcon im;
    ExtTechnoDesign etd;
    FilenameFilter filter;
    String imageFile=new String("cartoComprRel.jpg");
    
	public MapImage()
	{
		//{{INIT_CONTROLS
		setJMenuBar(JMenuBar1);
		setTitle("Map");
		getContentPane().setLayout(null);
		setSize(875,555);
		setVisible(false);
		getContentPane().add(JLabelBlock);
		JLabelBlock.setBounds(0,0,840,492);
		//$$ JMenuBar1.move(0,0);
		JMenu1.setText("Map");
		JMenu1.setActionCommand("Image");
		JMenuBar1.add(JMenu1);
		JMenuOpen.setText("Open");
		JMenuOpen.setActionCommand("Open");
		JMenu1.add(JMenuOpen);
		JMenuSupp.setText("Suppress");
		JMenuSupp.setActionCommand("Suppress");
		JMenu1.add(JMenuSupp);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		SymAction lSymAction = new SymAction();
		JMenuOpen.addActionListener(lSymAction);
		JMenuSupp.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

	    JMenuOpen.setText(resIntTh_fr.getString("Ouvrir")); 
		JMenuSupp.setText(resIntTh_fr.getString("Suppr"));
	}

	public MapImage(String title)
	{
		this();
		setTitle(title);
	}
	public MapImage(String title,ExtTechnoDesign etd,ImageIcon im)
	{
		this();
		this.im=im;
		this.etd=etd;
		setTitle(title);
/*		if(im!=null){
		    int w=im.getIconWidth();
		    int h=im.getIconHeight();
		    setBounds(0,0,w+5,h+50);
		    JLabelBlock.setIcon(new ImIcon(JLabelBlock,im,w,h));
		}*/
	}
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(0, 0);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == MapImage.this)
			MapImage_WindowClosing(event);
		}
	}

	void MapImage_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabelBlock = new javax.swing.JLabel();
	javax.swing.JMenuBar JMenuBar1 = new javax.swing.JMenuBar();
	javax.swing.JMenu JMenu1 = new javax.swing.JMenu();
	javax.swing.JMenuItem JMenuOpen = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuSupp = new javax.swing.JMenuItem();
	//}}

	//{{DECLARE_MENUS
	//}}
    
    public void setImageFile(String fileName){
        imageFile=fileName;
    }

	class SymComponent extends java.awt.event.ComponentAdapter
	{
		public void componentResized(java.awt.event.ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == MapImage.this)
				MapImage_componentResized(event);
		}
	}

	void MapImage_componentResized(java.awt.event.ComponentEvent event)
	{
		JLabelBlock.setBounds(0,0,getBounds().width-5,getBounds().height-50);
		JLabelBlock.setIcon(new ImIcon(JLabelBlock,im,JLabelBlock.getWidth(),JLabelBlock.getHeight()));
	}
	
	public void loadImage(){
    File fich2=null;
    try{
        
        fich2=new File("maps"+File.separator+imageFile);
		FileReader flux_fich = new FileReader(fich2);
		BufferedReader flux_tamp = new BufferedReader(flux_fich);
		String ligne_data;
		String dummy,message;
	        im=new ImageIcon("maps"+File.separator+imageFile);
		    int w=im.getIconWidth();
		    int h=im.getIconHeight();
		    setBounds(0,0,w+5,h+50);
		    JLabelBlock.setIcon(new ImIcon(JLabelBlock,im,w,h));
            repaint();
            etd.im=im;
            etd.imgFile=imageFile;
			etd.JLabeImg.setIcon(new ImIcon(etd.JLabeImg,im,etd.JLabeImg.getWidth(),etd.JLabeImg.getHeight()));
//			etd.JLabeImg.setIcon(new ImIcon(etd.JLabeImg,im,w,h));
            etd.JLabeImg.repaint();
            etd.JPanel1.repaint();
    }

	    catch(FileNotFoundException e) {
	        String message="Le_fichier"+" "+fich2.getAbsolutePath()+" est introuvable";  
	        JOptionPane.showMessageDialog(this,message);
	        e.printStackTrace();
	    }
		 catch(IOException e) {
		    String message="erreurIO"+"\n"+e.toString(); //modRG 02/01
            JOptionPane.showMessageDialog(this,message);//modRG 02/01
		    e.printStackTrace();
		 }
			 
	    
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JMenuOpen)
				JMenuOpen_actionPerformed(event);
			else if (object == JMenuSupp)
				JMenuSupp_actionPerformed(event);
		}
	}
/*            public boolean accept(File dir,String name){
                if(name.endsWith(".gif"))return true;
                if(name.endsWith(".GIF"))return true;
                return false;
            }*/

	void JMenuOpen_actionPerformed(java.awt.event.ActionEvent event)
	{
	    filter =new FilenameFilter(){
            public boolean accept(File dir,String name){
                if(name.endsWith(".gif"))return true;
                if(name.endsWith(".GIF"))return true;
                return false;
            }
        };
    
	    FileDialog ff = new FileDialog(this,"Open map ?",FileDialog.LOAD);   
       // ff.peer.setFilenameFilter(filter);
        ff.setFilenameFilter(filter);
        synchronized(ff){
            ff.setDirectory("maps");
        }
        ff.show();
        File dir=new File("maps");
        String[]liste=dir.list(filter);
/*        System.out.println(ff.getFilenameFilter().toString());
        for(int k=0;k<liste.length;k++){
            System.out.println(liste[k]);
        }*/

	    String nomfic = ff.getFile();
	    String directory=ff.getDirectory();
	    if(nomfic!= null){
            setImageFile(nomfic);
	        im=new ImageIcon(directory+nomfic);
		    int w=im.getIconWidth();
		    int h=im.getIconHeight();
		    setBounds(0,0,w+5,h+50);
		    JLabelBlock.setIcon(new ImIcon(JLabelBlock,im,w,h));
            repaint();
            etd.im=im;
            etd.imgFile=nomfic;
			etd.JLabeImg.setIcon(new ImIcon(etd.JLabeImg,im,etd.JLabeImg.getWidth(),etd.JLabeImg.getHeight()));
//			etd.JLabeImg.setIcon(new ImIcon(etd.JLabeImg,im,w,h));
            etd.JLabeImg.repaint();
            etd.JPanel1.repaint();
	    }
	}

	void JMenuSupp_actionPerformed(java.awt.event.ActionEvent event)
	{
 	    boolean resp=Util.Confirm(this,resIntTh_fr.getString("Suppr"), 
	    resIntTh_fr.getString("Annuler"),
        resIntTh_fr.getString("ATTENTION"),"Suppress map?");
        if(resp){
		    int w=im.getIconWidth();
		    int h=im.getIconHeight();
		    JLabelBlock.setIcon(new ImIcon(JLabelBlock,null,w,h));
            repaint();
            etd.im=null;
            etd.imgFile="";
//			etd.JLabeImg.setIcon(new ImIcon(etd.JLabeImg,null,etd.JLabeImg.getWidth(),etd.JLabeImg.getHeight()));
			etd.JLabeImg.setIcon(new ImIcon(etd.JLabeImg,im,w,h));
            etd.JLabeImg.repaint();
            etd.JPanel1.repaint();
		}
	}
}